// definition of clustering methods.
#ifndef METHOD_H
#define METHOD_H
#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <cstdlib>
#include <omp.h>
#include <cmath>
#include <utility>
#include <algorithm>
#include "Clustering.h"

#define INF 10000000

using namespace std;

class Average : public Clustering{
 public:
  Average(void){}
  Average(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const double t, const bool eval, const int core);
  void clustering(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void clustering_eval(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void update_first_node(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  //inline double calc_exp_dist(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const int &obj);
  inline double calc_exp_dist(vector<vector<double> > &exp_dist_table, const int &obj);
};

class Single : public Clustering{
 public:
  Single(void){}
  Single(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const double t, const bool eval, const int core);
  void clustering(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void clustering_eval(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void update_first_node(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  //inline double calc_exp_dist(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const int &obj);
  inline double calc_exp_dist(vector<vector<double> > &exp_dist_table, const int &obj);
};

class Complete : public Clustering{
 public:
  Complete(void){}
  Complete(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const double t, const bool eval, const int core);
  void clustering(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void clustering_eval(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void update_first_node(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  //inline double calc_exp_dist(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const int &obj);
  inline double calc_exp_dist(vector<vector<double> > &exp_dist_table, const int &obj);
};

class Ward : public Clustering{
 public:
  Ward(void){}
  Ward(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const double t, const bool eval, const int core);
  void clustering(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void clustering_eval(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  void update_first_node(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table);
  inline double calc_exp_dist(vector<MidNode *> *entry, vector<vector<double> > &exp_dist_table, const int &obj);
};

#endif
