// output clustering results.
#ifndef OUTPUT_H
#define OUTPUT_H
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <list>
#include <cstring>
#include <cstdlib>
#include <omp.h>
#include "Input.h"
#include "Clustering.h"

using namespace std;

class Output{
 protected:
  int stage;
  string output_newick;
  string output_genes;
  string output_log;
  ofstream newick_file;
  ofstream genes_file;
  ofstream log_file;
  list<GeneData *> genes;
  vector<double> exp;
  vector<int> test;

 public:
  Output(void){}
  Output(const MidNode *node, const vector<string> &labels, map<string, vector<int> > &log, const string output_prefix, const int s, const bool eval);
  void output_clustering_result(const MidNode *node, const vector<string> &labels);
  void output_clustering_log(map<string, vector<int> > &log);
};

void output_clustering_results(const MidNode *node, const vector<string> &labels, const string output_prefix, const int stage);

#endif
